angular.module('gaugesScreen', [])
.controller('GaugesScreenController', function($scope, $window) {
  var unit = null;
  var RPMNumber = null;
  $scope.data = {}
  // overwriting plain javascript function so we can access from within the controller
  $window.setUnits = (data) => {
    unit = data.unitType;
  }
  
  $window.updateData = (data) => {
    $scope.$evalAsync(function() {
	

	
    if (data.gear === -1) {
		$scope.data.gear = "R";
    }
    else if (data.gear === 0) {
		$scope.data.gear = "N";
    }
    else {
		$scope.data.gear = data.gear;
    }
	
	//messages
	if (data.checkEngine === true) {
		$scope.data.message = "CHECK ENGINE";
    }
	else if (data.oiltemp > 140) {
		$scope.data.message = "OIL TEMP";
    }
	else if (data.watertemp > 115) {
		$scope.data.message = "WATER TEMP";
    }
	else if (data.fuel < 1) {
		$scope.data.message = "LOW FUEL";
    }
	else if (data.parkingbrake === 1) {
		$scope.data.message = "PARK BRAKE";
    }
    else {
		$scope.data.message = "";
    }


	$scope.data.ripems = data.ripems;
    $scope.data.time = data.time;

      // checking if metric gauge cluster is being used
    if (unit === "metric") {
		$scope.data.speedVal = (data.speed * 3.6).toFixed(0);
        $scope.data.speedUnit = "KM/H";
		
        $scope.data.waterTempVal = data.watertemp
        $scope.data.oilTempVal = data.oiltemp
		$scope.data.tempUnit = "C";
		
        $scope.data.fuelQty = Math.floor(data.fuel*10) /10;
        $scope.data.fuelUnit = "L";
		
		
    }
    else {
        $scope.data.speedVal = (data.speed * 2.23694).toFixed(0);
		$scope.data.speedUnit = "MPH";
		
        $scope.data.waterTempVal = (data.watertemp * 1.8 + 32).toFixed(0);
        $scope.data.oilTempVal = (data.oiltemp * 1.8 + 32).toFixed(0);
		$scope.data.tempUnit = "F";;
		
        $scope.data.fuelQty = Math.floor(data.fuel / 3.785 *10) /10;
        $scope.data.fuelUnit = "Ga.";
    }
	
	//sweeping RPM gauge
	RPMNumber = Math.round(data.ripems / 100)
	for (i = 1; i < 71; i++) {
		if (i <= RPMNumber) {
			document.getElementById("RPM" + i).style.display = "";
		} 
		else {
			document.getElementById("RPM" + i).style.display = "none";	
		} 
	} 

	
    }
	)
 }
});    